/// <reference types="node" />
/// <reference types="@constl/orbit-db-types" />
import { type AccessController, type Identity, type Storage } from "@orbitdb/core";
import type { IPFS } from "ipfs-core";
export type FeedDatabaseType = Awaited<ReturnType<ReturnType<typeof Feed>>>;
declare const Feed: {
    (): ({ ipfs, identity, address, name, access, directory, meta, headsStorage, entryStorage, indexStorage, referencesCount, syncAutomatically, onUpdate, }: {
        ipfs: IPFS;
        identity?: Identity;
        address: string;
        name?: string;
        access?: AccessController;
        directory?: string;
        meta?: object;
        headsStorage?: Storage;
        entryStorage?: Storage;
        indexStorage?: Storage;
        referencesCount?: number;
        syncAutomatically?: boolean;
        onUpdate?: () => void;
    }) => Promise<{
        type: "feed";
        add: (value: unknown) => Promise<string>;
        remove: (hash: string) => Promise<string>;
        iterator: ({ amount, }?: {
            amount?: number;
        }) => AsyncGenerator<{
            value: unknown;
            hash: string;
        }, void, unknown>;
        all: () => Promise<{
            value: unknown;
            hash: string;
        }[]>;
        addOperation: (args: {
            op: string;
            key: string;
            value: unknown;
        }) => Promise<string>;
        address: string;
        close(): Promise<void>;
        drop(): Promise<void>;
        events: import("events");
        access: AccessController;
        log: import("@orbitdb/core").Log;
    }>;
    type: "feed";
};
export default Feed;
